module DeviseAuthentication::ApiBase
    extend ActiveSupport::Concern
    included do
        # rescue_from CanCan::AccessDenied, :with => :user_not_authorized
        # rescue_from AuthenticationError, :with => :user_not_authorized

        # This is called via basic authentication. Thus, we need to disable authenticity tokens.
        skip_before_filter :verify_authenticity_token, :only => [:index, :show, :create, :update]

        # Check Authentication before every action
        before_action :check_auth
    end

    def check_auth
        Rails.logger.debug "**check auth"
        authenticate_or_request_with_http_basic do |email,password|
            email    = email.force_encoding('UTF-8')
            password = password.force_encoding('UTF-8')
            resource = nil 
            begin 
                resource = DeviseAuthentication::User.find_for_authentication(:email => email)
            rescue Exception => e
                Rails.logger.info "** check_auth: Catching reconnect once and retry in order to handle timeouts: #{e}"
                resource = DeviseAuthentication::User.find_for_authentication(:email => email)
            end
            if resource.valid_password?(password)
                sign_in :user, resource
            end
        end
    end
end